#include "svc_rpc.h"
#include "json_rpc.h"
#include "tuya_ipc_cloud_storage.h"

static void rpc_ipc_server_tuya_ipc_cloud_storage_init(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;

    ret = tuya_ipc_cloud_storage_init();

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

static void rpc_ipc_server_tuya_ipc_cloud_storage_uninit(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;

    tuya_ipc_cloud_storage_uninit();

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

static void rpc_ipc_server_tuya_ipc_cloud_storage_get_store_mode(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;

    ret = tuya_ipc_cloud_storage_get_store_mode();

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

static void rpc_ipc_server_tuya_ipc_cloud_storage_event_start(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;

    ret = tuya_ipc_cloud_storage_event_start();

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

static void rpc_ipc_server_tuya_ipc_cloud_storage_event_stop(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;

    ret = tuya_ipc_cloud_storage_event_stop();

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

static void rpc_ipc_server_tuya_ipc_cloud_storage_event_stop_async(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;

    ret = tuya_ipc_cloud_storage_event_stop_async();

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

static void rpc_ipc_server_tuya_ipc_cloud_storage_get_event_status(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int comm = 0;
    int ret = 0;

    jrpc_read_int(request, JRPC_PARAMS, "comm", &comm);

    ret = tuya_ipc_cloud_storage_get_event_status(comm);

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

static void rpc_ipc_server_tuya_ipc_cloud_storage_get_status(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;

    ret = tuya_ipc_cloud_storage_get_status();

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

static void rpc_ipc_server_tuya_ipc_cloud_storage_pause(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;

    tuya_ipc_cloud_storage_pause();

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

static void rpc_ipc_server_tuya_ipc_cloud_storage_resume(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int ret = 0;

    tuya_ipc_cloud_storage_resume();

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

static void rpc_ipc_server_tuya_ipc_cloud_storage_set_audio_stat(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int comm = 0;
    int ret = 0;
    
    jrpc_read_int(request, JRPC_PARAMS, "comm", &comm);

    tuya_ipc_cloud_storage_set_audio_stat(comm);

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

static void rpc_ipc_server_tuya_ipc_cloud_storage_set_pre_record_time(jrpc_msg_t *request, void *arg, jrpc_msg_t *reply)
{
    int comm = 0;
    int ret = 0;

    jrpc_read_int(request, JRPC_PARAMS, "comm", &comm);

    ret = tuya_ipc_cloud_storage_set_pre_record_time(comm);

    jrpc_create_response(reply, 1);
    jrpc_write_int(reply, JRPC_RESULT, "code", ret);

    return;
}

void tuya_ipc_rpc_server_declare_cloud_storage()
{
    tuya_ipc_rpc_server_declare( "tuya_ipc_cloud_storage_init", rpc_ipc_server_tuya_ipc_cloud_storage_init, NULL);
    tuya_ipc_rpc_server_declare( "tuya_ipc_cloud_storage_uninit", rpc_ipc_server_tuya_ipc_cloud_storage_uninit, NULL);
    tuya_ipc_rpc_server_declare( "tuya_ipc_cloud_storage_get_store_mode", rpc_ipc_server_tuya_ipc_cloud_storage_get_store_mode, NULL);
    tuya_ipc_rpc_server_declare( "tuya_ipc_cloud_storage_event_start", rpc_ipc_server_tuya_ipc_cloud_storage_event_start, NULL);
    tuya_ipc_rpc_server_declare( "tuya_ipc_cloud_storage_event_stop", rpc_ipc_server_tuya_ipc_cloud_storage_event_stop, NULL);
    tuya_ipc_rpc_server_declare( "tuya_ipc_cloud_storage_event_stop_async", rpc_ipc_server_tuya_ipc_cloud_storage_event_stop_async, NULL);
    tuya_ipc_rpc_server_declare( "tuya_ipc_cloud_storage_get_event_status", rpc_ipc_server_tuya_ipc_cloud_storage_get_event_status, NULL);
    tuya_ipc_rpc_server_declare( "tuya_ipc_cloud_storage_get_status", rpc_ipc_server_tuya_ipc_cloud_storage_get_status, NULL);
    tuya_ipc_rpc_server_declare( "tuya_ipc_cloud_storage_pause", rpc_ipc_server_tuya_ipc_cloud_storage_pause, NULL);
    tuya_ipc_rpc_server_declare( "tuya_ipc_cloud_storage_resume", rpc_ipc_server_tuya_ipc_cloud_storage_resume, NULL);
    tuya_ipc_rpc_server_declare( "tuya_ipc_cloud_storage_set_audio_stat", rpc_ipc_server_tuya_ipc_cloud_storage_set_audio_stat, NULL);
    tuya_ipc_rpc_server_declare( "tuya_ipc_cloud_storage_set_pre_record_time", rpc_ipc_server_tuya_ipc_cloud_storage_set_pre_record_time, NULL);

    return;
}
