/*********************************************************************************
  *Copyright(C),2015-2020, TUYA www.tuya.comm
  *FileName:    tuya_ipc_media_update_demo
**********************************************************************************/
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include "tuya_ipc_media_update_demo.h"
#include "tuya_ipc_media_adapter.h"
#include "tuya_ipc_log_demo.h"

int g_meida_update_type = MEDIA_UPDATE_H264;
int g_media_update_wait = 0;

VOID IPC_APP_Media_Adapter_Set(TUYA_IPC_SDK_MEDIA_STREAM_S *p_media_infos)
{
    DEVICE_MEDIA_INFO_T device_media_info = { 0 };
    memcpy(&device_media_info.av_encode_info, &p_media_infos->media_info,sizeof(IPC_MEDIA_INFO_T));
    
    device_media_info.audio_decode_info.enable = 1;
    device_media_info.audio_decode_info.audio_codec = TUYA_CODEC_AUDIO_G711U;
    device_media_info.audio_decode_info.audio_sample = TUYA_AUDIO_SAMPLE_8K;
    device_media_info.audio_decode_info.audio_databits = TUYA_AUDIO_DATABITS_16;
    device_media_info.audio_decode_info.audio_channel = TUYA_AUDIO_CHANNEL_MONO;
    
    device_media_info.max_pic_len = MAX_SNAPSHOT_BUFFER_SIZE;
    PR_DEBUG("IPC_APP_Media_Adapter_Set video_codec:%d\n",device_media_info.av_encode_info.video_codec[E_IPC_STREAM_VIDEO_MAIN]);

    tuya_ipc_media_adapter_set_media_info(0, 0, device_media_info);
#if defined(IPC_CHANNEL_NUM) && (IPC_CHANNEL_NUM==2)
    tuya_ipc_media_adapter_set_media_info(0, 1, device_media_info);
#endif    

    return;
}

VOID IPC_APP_Set_Media_Update_Type(MEDIA_UPDATE_TYPE_E type)
{
    g_meida_update_type = type ;
}

VOID IPC_APP_Set_Media_Update_Wait(int wait)
{
    g_media_update_wait = wait ;
}
